
## ddpcRquant Shiny Application: server ##


shinyServer(function(input, output, session) {
  
  #eventReactive(input$reset, {rm(list=ls())})
  
  start <- eventReactive(input$start, {
  
    if (input$assay_demo =="Upload ddpcrfiles") {
      
      ddpcrfiles <<- input$files
      to <<- file.path(dirname(ddpcrfiles[['datapath']]),
                                            basename(ddpcrfiles[['name']]))
      file.rename(ddpcrfiles[['datapath']], to)
      ddpcrfiles[['datapath']] <<- file.path(dirname(ddpcrfiles[['datapath']]),
                                            basename(ddpcrfiles[['name']]))
      if (is.null(ddpcrfiles))
      {return(NULL)}
      
      files <- as.matrix(ddpcrfiles$name)
      colnames(files) <- "FileName"
      files
    }
    
    else{
      
      files <- as.matrix(ddpcrfiles_demo1)
      colnames(files) <- "FileName"
      files
      
    }
    
    
})
  observeEvent(input$reset, {js$reset()})
  
  output$files <- renderTable(start())

  assays_detected <- eventReactive(input$start, {
    
    if (input$assay_demo == "Upload ddpcrfiles") {
      
      #ddpcrfiles <- input$files
      head_upload <<- read.csv(file=ddpcrfiles$datapath[1], header = TRUE,row.names=NULL)
      
      if(input$qx == "qx100"){
      head_filtered <<- head_upload[,c("Well","Sample","TypeAssay","Assay")]
      
      } 
      if(input$qx == "qx200"){
        
        head_upload[,64] <- rownames(head_upload)
        colnames(head_upload) <- c(colnames(head_upload)[2:dim(head_upload)[2]],"Well")
        head_filtered <<- head_upload[,c("Well","Sample","TargetType","Target")]
        colnames(head_filtered) <- c("Well","Sample","TypeAssay","Assay")
      }
    
      amplitudefiles <<- ddpcrfiles$datapath[-1]
      
      assays <<- unique(head_filtered$Assay)
      
      list_assays=list()
      for(i in 1:length(assays)){
        name <- as.character(assays[i])
        list_assays[[name]] <- head_filtered[head_filtered$Assay==assays[i],]
      }
      list_assays <<- list_assays
      
      #ntc ids per assay
      ntc=list()
      ntc_id=list()
      for(j in 1:length(list_assays)){
        list_assays_tmp <- list_assays[[j]]
        name <- as.character(assays[j])
        ntc[[name]] <- list_assays_tmp[grep("NTC",list_assays_tmp$Sample, 
                                            ignore.case = TRUE),]
        ntc_id[[name]] = as.matrix(ntc[[j]]$Well)
      }
      
      ntc_id <<- ntc_id
      
      #sample ids per assay
      sample=list()
      sample_id=list()
      for(j in 1:length(list_assays)){
        list_assays_tmp <- list_assays[[j]]
        name <- as.character(assays[j])
        sample[[name]] <- list_assays_tmp[-grep("NTC",list_assays_tmp$Sample, ignore.case = TRUE),]
        sample_id[[name]] = as.matrix(sample[[j]]$Well)
      }
      sample_id <<- sample_id
      
      assays <- as.matrix(assays)
      colnames(assays) <- "Assays detected upload"
      assays
    }
    
    else {
     
      headfile <<- ddpcrfiles_demo1[-grep("Amplitude", ddpcrfiles_demo1)]
      amplitudefiles <<- list.files(path="./shiny_data/", pattern="*Amplitude.csv")
      head_demo <<- read.csv(file=paste("./shiny_data/",headfile, sep=""), 
                            header=TRUE)
      if(input$qx =="qx100"){
      
      head_filtered <<- head_demo[,c("Well","Sample","TypeAssay","Assay")]
      assays_demo <- unique(head_filtered$Assay)
      
      list_assays=list()
      for(i in 1:length(assays_demo)){
        name <- as.character(assays_demo[i])
        list_assays[[name]] <- head_filtered[head_filtered$Assay==assays_demo[i],]
      }
      list_assays <<- list_assays
      
      #ntc ids per assay
      ntc=list()
      ntc_id=list()
      for(j in 1:length(list_assays)){
        list_assays_tmp <- list_assays[[j]]
        name <- as.character(assays_demo[j])
        ntc[[name]] <- list_assays_tmp[grep("NTC",list_assays_tmp$Sample, 
                                            ignore.case = TRUE),]
        ntc_id[[name]] = as.matrix(ntc[[j]]$Well)
      }
      
      ntc_id <<- ntc_id
      
      #sample ids per assay
      sample=list()
      sample_id=list()
      for(j in 1:length(list_assays)){
        list_assays_tmp <- list_assays[[j]]
        name <- as.character(assays_demo[j])
        sample[[name]] <- list_assays_tmp[-grep("NTC",list_assays_tmp$Sample, ignore.case = TRUE),]
        sample_id[[name]] = as.matrix(sample[[j]]$Well)
      }
      sample_id <<- sample_id
      
      assays_demo <- as.matrix(assays_demo)
      colnames(assays_demo) <- "Demo Assays"
      
      assays_demo
      }
    }
  })
  output$assay_info <- renderTable({assays_detected()})
  output$assay_ntcs <- renderTable({
    
    max_length <- max(unlist(lapply(ntc_id,length)))
    ntc_id_filled <- lapply(ntc_id,function(x) {ans <- rep("",length=max_length);
                                                      ans[1:length(x)]<- x;
                                                      return(ans)})
    ntcs <- do.call(rbind, ntc_id_filled)
    colnames(ntcs) <- 1:dim(ntcs)[2]
    ntcs
    })
  output$assay_samples <- renderTable({
    max_length <- max(unlist(lapply(sample_id,length)))
    sample_id_filled <- lapply(sample_id,function(x) {ans <- rep("",length=max_length);
                                                  ans[1:length(x)]<- x;
                                                  return(ans)})
    samples <- do.call(rbind, sample_id_filled)
    colnames(samples) <- 1:dim(samples)[2]
    samples
    })

  assays_interactive <- eventReactive(input$start, {
    if (input$assay_demo == "Upload ddpcrfiles") {
      
      head_upload <- read.csv(file=ddpcrfiles$datapath[1], header = TRUE,row.names=NULL)
      
      if(input$qx == "qx100"){
        head_filtered <<- head_upload[,c("Well","Sample","TypeAssay","Assay")]
        
      } 
      if(input$qx == "qx200"){
        
        head_upload[,64] <- rownames(head_upload)
        colnames(head_upload) <- c(colnames(head_upload)[2:dim(head_upload)[2]],"Well")
        head_filtered <<- head_upload[,c("Well","Sample","TargetType","Target")]
        colnames(head_filtered) <- c("Well","Sample","TypeAssay","Assay")
      }
      
      assays <- unique(head_filtered$Assay)
      assays <- as.matrix(assays)
      colnames(assays) <- "Assays detected upload"
      selectInput('assays_choice', 'Choose one of the detected assays', assays)
    }
    
    else {
      if(input$qx == "qx100"){
      head_filtered <- head_demo[,c("Well","Sample","TypeAssay","Assay")]
      assays_demo <- unique(head_filtered$Assay)
      assays_demo <- as.matrix(assays_demo)
      colnames(assays_demo) <- "Assays detected"
      selectInput('assays_choice', 'Choose one of the detected assays', assays_demo)
      }
    }
  })
  output$assays <- renderUI({assays_interactive()})

  params <- eventReactive(input$go, {
    #runif(input$blocks & input$reps & input$vol.mix & input$vol.tmp)
    blocks <<- input$blocks
    reps <<- input$reps
    vol.mix <<- input$vol.mix
    vol.tmp <<- input$vol.tmp
    choice <<- input$assays_choice
    ci.conc.method <<- input$CI_calculation
    ci.conc <<- input$ci_conc
    threshold.manual <<- input$man.threshold
    cutoff.quantile <<- input$int.threshold/100
    })
    
  plotNTC <- function(){
    set.seed(1553)
    params()
    #split <<- blocks
    l <- as.character(choice)
    #reps <- input$reps
    #reps <- repls()
    tmp_ntc <<- regexpr("Amplitude.csv", amplitudefiles)
    tmp_sample <<- regexpr("Amplitude.csv", amplitudefiles)
    
   
      #Defining variables
      ntc_file <- c()
      ntc_file_corr <- c()
      channel <- c()
      report_ntc <- c()
      
      
      if(unique(list_assays[[l]]$TypeAssay)=="Ch1Unknown"
         |unique(list_assays[[l]]$TypeAssay)=="Ch1NTC"){
        channel <- 1
      } else{
        channel <- 2
      }
      
    corr_factor <<- c(1:length(ntc_id[[l]]))
    
      for(k in 1:length(ntc_id[[l]])){
        for(j in 1:length(amplitudefiles)){
          
          match <- substr(amplitudefiles[j], tmp_ntc-4, tmp_ntc-2)
          
          if (match == ntc_id[[l]][k]){
            
            #######READ NTCS#######
            
            if (input$assay_demo =="Upload ddpcrfiles") {
            ntc_file_tmp <- read.csv(file=amplitudefiles[j], header = T)
            
            } else {
            ntc_file_tmp <- read.csv(file=paste("./shiny_data/", amplitudefiles[j], sep=""), header = T)
            }
            
            #######BASELINE TO ZERO BASED ON ROBUST MODE#######
            corr_factor[k] <<- hsm(ntc_file_tmp[,channel])
            ntc_file_corr <- ntc_file_tmp[,channel] - corr_factor[k]
            
            #######MERGE NTCS#######
            ntc_file <- c(ntc_file, ntc_file_corr)
          }
        }}       
      
      ##### PLOT MERGED NTC ####
      random_ntc_file <<- sample(ntc_file)
      density_max_merge <- 0
      density_max_merge <- hsm(ntc_file)
      
      if(threshold.manual == 0){
      quantgev<-array(0,reps)
      
      #start repeated calculations
      for(k in 1:reps){
        print(k) #TRACK PROGRESS
        
        ### block creation
        random_ntc_file <- sample(random_ntc_file)
        size<-floor(length(random_ntc_file)/(blocks*length(ntc_id[[l]]))) #block size
        ssize<- c(rep(size,blocks*length(ntc_id[[l]])-(length(random_ntc_file)-size*blocks*length(ntc_id[[l]]))),
                  rep(size+1,length(random_ntc_file)-(size*blocks*length(ntc_id[[l]])))) #blocks remaining droplets over samples so no droplets get discarded
        signal.maxima<-array(0,blocks) #to store the block maximums
        
        ### determine maxima of subsamples
        droplets2<-sample(random_ntc_file)
        for(i in 1:blocks){
          signal.maxima[i]<-max(droplets2[1:ssize[i]])
          droplets2<-droplets2[-c(1:ssize[i])]
        }
        
        signal.maxima<-as.numeric(signal.maxima)
        
        
        ## fit the GEV model using ML
        droplet.fit <- try(fgev(signal.maxima), silent=TRUE)
        
        quantgev[k]<-try(qgev(cutoff.quantile,droplet.fit$estimate[1],
                              droplet.fit$estimate[2],droplet.fit$estimate[3]), silent =TRUE)
        if(quantgev[k] > max(random_ntc_file)+5000){quantgev[k] <- NA}
        
      }
      
      #calculate final threshold
      threshold<<-mean(as.numeric(quantgev), na.rm=TRUE)
      
      } else { threshold <<- threshold.manual}
    
      report_thresh <- rbind(report_thresh, threshold)
      rownames(report_thresh) <- as.character(l)
      
      ######POSITIVE AND NEGATIVE DROPLETS########
      pos_drops <- random_ntc_file[random_ntc_file>threshold]
      neg_drops <- random_ntc_file[random_ntc_file<=threshold]
      nr_pos_drops <-length(pos_drops)
      nr_neg_drops <-length(neg_drops)
      tot <- length(random_ntc_file)
      
      ########PLOT#########

      
    
      if(nr_pos_drops != 0){
        dpcr <- dpcr_density(nr_pos_drops,tot, average = TRUE, 
                             methods = ci.conc.method, 
                             conf.level = ci.conc, plot = FALSE)
        
        conc <- (1000/0.91 * dpcr$lambda)*(vol.mix/vol.tmp)
        conc_lower <- (1000/0.91 * dpcr$lower)*(vol.mix/vol.tmp)
        conc_upper <- (1000/0.91 * dpcr$upper)*(vol.mix/vol.tmp)
        
      } else{ 
        conc_lower <- 0
        conc_upper <- 0
        conc <- 0
      }
      
      report_ntc <<- c("merged", as.character(l), 
                      "merged_NTC", "ntc", nr_pos_drops, 
                      nr_neg_drops, tot, round(conc, digits=4), 
                      round(conc_lower, digits=4), round(conc_upper, digits=4))
    
      ymax <- max(c(threshold,max(random_ntc_file))) + 1000
    
      plotntc <- plot(random_ntc_file, main="",ylim=c(min(random_ntc_file),ymax),
         cex = 0.8, pch=20)
      abline(h = threshold, col=2, lty=4)
    
      report <- paste("pos: ",nr_pos_drops," neg: ",nr_neg_drops," tot: ",
                    tot,"threshold: ",round(threshold,digits=2))
      name_thres <- paste("merged_ntc_threshold_",l,".png", sep="")
      title(name_thres,report)
      return(plotntc)
  }
  output$ntc_plot <- renderPlot({
    withProgress(message="Calculating results. Please wait.\n", value=0, {
      plotNTC()})
      })
  output$downloadPlot <- downloadHandler( filename = "NTC_plot.png", 
  content = function(file) {
    png(file)
    plotNTC()

    dev.off()
  }) 

  get_plot_output_list <- function(max, download = "not ok"){
  
  plot_output_list <- lapply(1:max, function(a) {

    print(a)
    plotname <- paste("plot", a, sep="")
    object <- plotOutput(plotname, height = 300, width = 350)
      
    tmp_sample <- regexpr("Amplitude.csv", amplitudefiles)
    corr_factor <<- max(corr_factor)
    if (a==1){
      if(unique(list_assays[[choice]]$TypeAssay)=="Ch1Unknown"
         |unique(list_assays[[choice]]$TypeAssay)=="Ch1NTC"){
        channel <<- 1
        report_sample <<- c()
      } else{
        channel <<- 2
        report_sample <<- c()
      }
      name_sample_ls <<- c()
      report_ls <<- c()
      random_sample_file_corr_ls <<- list()
    }
    
    for(b in 1:length(amplitudefiles)){
      print(b)
      #if (input$assay_demo == "Upload ddpcrfiles") {
      #amplitudefiles <<- list.files(path=ddpcrfiles$datapath, pattern="*Amplitude.csv")
      #amplitudefiles <<- ddpcrfiles$datapath[-1]
      #} else {
      #amplitudefiles <<- list.files(path="./shiny_data/", pattern="*Amplitude.csv")
      #}
      
      match_sample <<- substr(amplitudefiles[b], tmp_sample-4, tmp_sample-2)
      
      if (match_sample == sample_id[[choice]][a]){
      print(match_sample)  
        #######READ SAMPLE FILE#######
        
        if (input$assay_demo == "Upload ddpcrfiles") {
          sample_file<-read.csv(file=paste(amplitudefiles[b], sep="")
                                , header = TRUE)
          
        }
        
        else {
          sample_file<-read.csv(file=paste("./shiny_data/", amplitudefiles[b], sep="")
                                , header = TRUE)
        }
        
        #######RANDOMIZE SAMPLE#######
        random_sample_file <- sample(sample_file[,channel])
        
        ##baseline to zero depending robust mode
        window <- subset(random_sample_file, 
                         random_sample_file < threshold + corr_factor) 
        
        window.mode <- hsm(window)
        if(is.na(window.mode)){window.mode = 0}
        
        random_sample_file_corr <<- random_sample_file - window.mode
        random_sample_file_corr_ls[[a]] <<- random_sample_file_corr
      
        ######RETURN POSITIVE AND NEGATIVE DROPLETS########
        pos_drops <<- sum(random_sample_file_corr>threshold)
        neg_drops <<- sum(random_sample_file_corr<=threshold)
        
        tot <<- length(random_sample_file_corr)
        
        ###PINHEIRO CONCENTRATION CALCS        
        if(pos_drops != 0){
          dpcr <- dpcr_density(pos_drops,tot, average = TRUE, 
                               methods = ci.conc.method, 
                               conf.level = ci.conc, plot = FALSE)
          conc <- (1000/0.91 * dpcr$lambda)*(vol.mix/vol.tmp)
          conc_lower <- (1000/0.91 * dpcr$lower)*(vol.mix/vol.tmp)
          conc_upper <- (1000/0.91 * dpcr$upper)*(vol.mix/vol.tmp)
          
        } else{ 
          conc <- 0
          conc_lower <- 0
          conc_upper <- 0
        }
        
        report <<- paste("pos: ",pos_drops," neg: ",neg_drops," tot: ",
                         tot," conc: ",round(conc, digits=4),"copies/uL stock")
      
        report_ls[a] <<- paste("pos: ",pos_drops," neg: ",neg_drops," tot: ",
                          tot," conc: ",round(conc, digits=4),"copies/uL stock")
      
        tmp_rep <<- c(match_sample, as.character(choice), 
                      as.character(list_assays[[choice]][list_assays[[choice]]$Well == match_sample ,]$Sample), "sample", 
                      pos_drops, neg_drops, tot, round(conc, digits=4), 
                      round(conc_lower, digits=4), round(conc_upper, digits=4))
        
        name_sample <<- paste(choice,match_sample,
                              list_assays[[choice]][list_assays[[choice]]$Well == match_sample,]$Sample,sep="_")
        name_sample_ls[a] <<- paste(choice,match_sample,
                               list_assays[[choice]][list_assays[[choice]]$Well == match_sample,]$Sample,sep="_")
      
      }
      
    }
    
    report_sample <<- rbind(report_sample, tmp_rep)
    
    if(download == "ok"){
      plot(random_sample_file_corr, main="",cex = 0.8, pch=20, 
           ylim=c(min(random_sample_file_corr), 
                  max(random_sample_file_corr+1000)))
      
      abline(h = threshold, col=2, lty=4)
      text(1000,threshold,round(threshold, digits=2), col=2)
      title(name_sample,report)
    }
    else {
    object <- renderPlot({
      plot(random_sample_file_corr_ls[[a]], main="",cex = 0.8, pch=20, 
           ylim=c(min(random_sample_file_corr_ls[[a]]), 
                  max(random_sample_file_corr_ls[[a]]+1000)))
      
      abline(h = threshold, col=2, lty=4)
      text(1000,threshold,round(threshold, digits=2), col=2)
      title(name_sample_ls[a],report_ls[a])

    })}
    
  })
  do.call(tagList, plot_output_list)
  return(plot_output_list)
 
}
  output$plots <- renderUI({input$go
                            withProgress(message="Calculating results. Please wait.\n", value=0, {
                          
                            get_plot_output_list(length(sample_id[[choice]]))})
                          })
  output$downloadPlots <- downloadHandler( filename = "sample_plots.pdf", 
                            content = function(file) {

                                pdf(file)
                                get_plot_output_list(length(sample_id[[choice]]),"ok")
                                dev.off()
                              
                                        }) 

#output$downloadPlots <- downloadHandler( filename = "sample_plots.png", 
#                                         content = function(file) {
#                                           
#                                           png(file)
#                                           get_plot_output_list(length(sample_id[[choice]]),"ok")
#                                           dev.off()
 #                                          
#                                         }) 

  summary_output <- eventReactive(input$go,{
  
  final_report <<- rbind(report_ntc, report_sample)
  colnames(final_report) <- c("Well", "assay", "name", "type", 
                              "positive droplets", "negative droplets", 
                              "total droplets", "concentration", 
                              "lowerCI", "upperCI")
    final_report <<- final_report
  final_report
  
})
  output$summary <- renderTable({summary_output()})

  summary_params <- eventReactive(input$go,{
  
  report_params <<- as.matrix(c(blocks, reps, vol.mix, vol.tmp, ci.conc.method, ci.conc,
                                threshold, cutoff.quantile, threshold.manual))
  
  rownames(report_params) <- c("Block size", "Repeats", "Vol Mix", "Vol tmp", 
                               "CI Concentration Method", "CI concentration", 
                               "threshold", "cut-off quantile threshold", 
                               "manual threshold")
  colnames(report_params) <- c("Parameters Used")
  
  report_params <<- report_params
  report_params
  
  })
  output$summary_params <- renderTable({summary_params()})

  repl_results <- eventReactive(input$start_rep,{
    withProgress(message="Calculating results. Please wait.\n", value=0, {
    print(report_sample)
    samples <- unique(report_sample[,3])
    data<-NULL
    for(i in 1:length(samples)){
    	 data.temp<-as.numeric(report_sample[which(report_sample[,3]==samples[i]),5:6])
    	 data<-rbind(data,data.frame(gene=samples[i],pos=data.temp[1:(length(data.temp)/2)],neg=data.temp[(length(data.temp)/2+1):length(data.temp)],target=T))
    }
    report_repl<<-get.estimates(data,fit.set(data)) 
    })
    colnames(report_repl) <- c("name", "concentration", 
                                "lowerCI", "upperCI")
    report_repl
  })  

  output$replicate <- renderTable({repl_results()})

  global_plot <- eventReactive(input$start_rep,{
  
    rep <- c(NA, as.numeric(report_ntc[8:10]))
    report_global <- rbind(rep, report_repl)
    
    x <- c(1:dim(report_global)[1])
    
    plot(x, report_global$est,xaxt="n",
         ylim=range(c(report_global$est.low, report_global$est.high), finite=TRUE),
         #xlim=range(c(1:dim(report_repl)[1])),
         pch=19, 
         #xlab="Samples", 
         ylab="Mean copies",
         main=paste(choice, " results")
    )
    
    arrows(x, report_global$est.low, x, report_global$est.high, length=0.05, 
           angle=90, code=3)
    axis(1, at=c(1:dim(report_global)[1]), 
         labels=c("merged_NTC",as.character(report_global$genenames[-1])), las=2 )
    })

  output$globalplot <- renderPlot({global_plot()})

  output$downloadData <- downloadHandler( filename = function() { 
  paste("summary_", choice, "_",format(Sys.time(), "%b_%d_%Y"),'.csv', sep='') 
  },
  content = function(file) {
  write.csv(final_report, file)
})

  output$downloadParam <- downloadHandler( filename = function() { 
    paste("summary_paramaters_", choice,"_",format(Sys.time(), "%b_%d_%Y"),'.csv', sep='') 
  },
  content = function(file) {
    write.csv(report_params, file)
  })

  output$downloadglobal <- downloadHandler( filename = "Assay_result.png", 
  content = function(file) {
                                              png(file)
                                              global_plot()
                                              
                                              dev.off()
                                            }) 
  
  output$downloadRepl <- downloadHandler( filename = function() { 
    paste("replicate", '.csv', sep='') 
  },
  content = function(file) {
    write.csv(report_repl, file)
  })

})


#EOS#
